#include <stdio.h>
#include <string.h>
#include <math.h>
#include <vector>
#include <string>

using namespace std;

struct Info{
	double speed;	/* 1߂ɂ鎞ԁimɂ́Al4ɂ鎞ԁj */
	vector<int> base;	/* Pʂœ͂Ă邩 */
	int base_pos;
	bool base_half;	/* 21iރ[hɓĂ邩 */
	double time;
	int beat_nu, beat_de;	/* ꏬ߂̕q/ */
	int beat_int;	/* ݂̔A[ */
	double beat_frac;
	/* A[(-1,0]ɎBF2.25ځi165j2,-0.75 */
};

void setSpeed(Info &info, char *str){
	int k;
	double t;
	/* = ǂ */
	char *ptr = strtok(str, "= \t\n");
	if(ptr == NULL){
		throw __LINE__;
	}
	int n = sscanf(ptr, "%d", &k);
	if(n < 1){
		throw __LINE__;
	}
	ptr = strtok(NULL, " \t\n");
	if(ptr == NULL){
		throw __LINE__;
	}
	n = sscanf(ptr, "%lf", &t);
	if(n < 1){
		throw __LINE__;
	}
	if(k <= 0){	/* kk͐ */
		throw __LINE__;
	}
	if(t <= 0.0){	/* e|łȂƂ */
		throw __LINE__;
	}
	info.speed =  60.0 / (t / k);
	return;
}

void setBase(Info &info, char *str){
	info.base.clear();
	for(char *ptr = strtok(str, ", \t\n"); ptr != NULL;
			ptr = strtok(NULL, ", \t\n")){
		int k;
		int n = sscanf(ptr, "%d", &k);
		if(n < 1){
			throw __LINE__;
		}
		if(k <= 0){	/* kk͐ */
			throw __LINE__;
		}
		info.base.push_back(k);
	}
	if(info.base.empty()){
		throw __LINE__;
	}
	return;
}

void setBeat(Info &info, char *str){
	int nu, de;
	/* / ǂ */
	char *ptr = strtok(str, "/ \t\n");
	if(ptr == NULL){
		throw __LINE__;
	}
	int n = sscanf(ptr, "%d", &nu);
	if(n < 1){
		throw __LINE__;
	}
	if(nu <= 0){	/*  0ȉŔq */
		info.beat_nu = 0;
		info.beat_de = 0;
		info.beat_int = 0;
		info.beat_frac = 0.0;
		return;
	}
	ptr = strtok(NULL, ": \t\n");
	if(ptr == NULL){
		throw __LINE__;
	}
	n = sscanf(ptr, "%d", &de);
	if(n < 1){
		throw __LINE__;
	}
	if(de <= 0){	/* ͐ */
		throw __LINE__;
	}
	
	ptr = strtok(NULL, " \t\n");
	if(ptr == NULL){
		info.beat_int = 0;	/* ʒuݒ肵ȂꍇA0ڂɂȂ */
		info.beat_frac = 0.0;
	}else{
		double d;
		n = sscanf(ptr, "%lf", &d);
		if(n < 1){
			throw __LINE__;
		}
		info.beat_int = ceil(d);
		info.beat_frac = d - info.beat_int;
	}
	info.beat_nu = nu;
	info.beat_de = de;
	
	info.beat_int %= info.beat_nu;
	return;
}

void timeAdd(Info &info, vector<pair<double, int> > &timeArray){
	if(info.speed <= 0.0){
		throw __LINE__;
	}
	if(info.base.empty()){
		throw __LINE__;
	}
	double length = 1.0 / info.base[info.base_pos++];
	info.base_pos %= info.base.size();
	if(info.base_half){
	    length /= 2;
	}
	double dTime, dBeat;
	dTime = length * info.speed;
	if(info.beat_de > 0){	/* q`Ă */
		dBeat = length * info.beat_de;
		while(info.beat_frac + dBeat > -0.001){	/* 덷ꉞCɂȂB0.999ȍ~Ƀe|ς邱Ƃ͂܂Ȃ낤B */
			timeArray.push_back(make_pair(
				info.time - info.speed * (info.beat_frac / info.beat_de),	/* info.time 瑫Ȃ₷ibeat_frac͕j */
				(info.beat_int == 0) ? -1 : -2));
			
			info.time += info.speed / info.beat_de;	/* ꔏԂi߂ */
			//length -= 1.0 / info.beat_de;
			dTime -= info.speed / info.beat_de;
			
			info.beat_int++;
			if(info.beat_int == info.beat_nu){
				info.beat_int = 0;
			}
			dBeat -= 1.0;
		}
		info.beat_frac += dBeat;
	}
	info.time += dTime;
	return;
}

void processCommand(char *str, Info &info){
	switch(str[0]){
	case 't':	/* t4=120 : lꕪ120 */
		setSpeed(info, str + 1);
		break;
	case 'b':	/* ͂nnݒ */
	case 'l':	/* ͂nnݒ */
		setBase(info, str + 1);
		break;
	case 'B':	/* qݒiFB4/4jAB0ŉ */
		setBeat(info, str + 1);
		break;
	case 'r':	/* r0.30.3bi߂ */
		{
		double t;
		int n = sscanf(str + 1, "%lf", &t);
		if(n < 1){
			throw __LINE__;
		}
		info.time += t;
		}
		break;
	default:
		throw __LINE__;
	}
}

int main1(char *fileName){
	char directoryName[256];
	strcpy(directoryName, fileName);
	for(int i = strlen(directoryName) - 1; i >= 0; i--){	/* 납炽ǂ */
		if(directoryName[i] == '/' || directoryName[i] == '\\'){	/* '/''\'ꂽ */
			directoryName[i + 1] = '\0';	/* ܂łȂ̂ŁA'\0' */
			goto L2;
		}
	}
	/* Ō܂ŌȂ */
	directoryName[0] = '\0';
L2:
	
	FILE *fp;
	fp = fopen(fileName, "r");
	if(!fp){
		throw __LINE__;
	}
	
	Info info;
	info.speed = -1.0;	/* 1߂ɂ鎞 */
	info.base.clear();	/* Pʂœ͂Ă邩 */
	info.base_pos = 0;
	info.base_half = false;
	info.time = 0.0;
	
	info.beat_nu = 0;
	info.beat_de = 0;
	
	info.beat_int = 0;	/* ŏ0ڂƂ */
	info.beat_frac = 0.0;
	
	vector<pair<double, int> > timeArray;
		/* int́A0:؂, 1:ł̎, 2:\̎ */
		/* 3:12˂, -1:ߐ, -2:uv */
	vector<string> lyricsArray;	/* ł̎iǂݕj */
	vector<string> lyricsKanjiArray;	/* 镶ƕʂɕ\̎ */
	
	char buf[1024];
	
	if(fgets(buf, sizeof(buf), fp) == NULL){
		throw __LINE__;
	}
	int len = strlen(buf);
	if(buf[len-1] == '\n'){
		buf[len-1] = '\0';
	}
	char outFileName[256];
	sprintf(outFileName, "%s%s", directoryName, buf);	/* 1sڂŏo̓t@Cw */
	//sprintf(outFileName, "%s%s-debug.txt", directoryName, buf);	/* 1sڂŏo̓t@Cw */
	printf("%sɏo͂܂B\n", outFileName);
	freopen(outFileName, "w", stdout);
	
	if(fgets(buf, sizeof(buf), fp) == NULL){
		throw __LINE__;
	}
	printf("@%s", buf);	/* 2sڂ͋ȃt@Ĉł̂܂܏o */
	
	while(fgets(buf, sizeof(buf), fp) != NULL){
		switch(buf[0]){
		case 'e':
			goto L1;	/* ȍ~̍s𖳎 */
		case '#':	/* Rgs */
			break;
		case '@':	/* 1s */
			processCommand(buf + 1, info);
			break;
		case '\'':	/* ł̎ipXy[XA^u؂j */
			for(char *ptr = strtok(buf + 1, " \t\n"); ptr != NULL;
					ptr = strtok(NULL, " \t\n")){
				lyricsArray.push_back(string(ptr));
			}
			break;
		case '\"':	/* \̎i^u؂jiĂAʋ؂Ȃj */
			for(char *ptr = strtok(buf + 1, "\t\n"); ptr != NULL;
					ptr = strtok(NULL, "\t\n")){
				lyricsKanjiArray.push_back(string(ptr));
			}
			break;
		default:
			for(char *ptr = buf; *ptr != '\0'; ptr++){
				switch(*ptr){
				case '[':	/* R}hJn */
					{
						ptr++;
						char *ptrCmd = ptr;	/* R}h̊Jnʒu */
						while(*ptr != ']'){
							if(*ptr == '\0'){	/* R}hȂ */
								throw __LINE__;
							}
							ptr++;
						}
						*ptr = '\0';	/* ']''\0'ɏ */
						processCommand(ptrCmd, info);
					}
					break;
				case ']':	/* R}hJĂȂ̂ɕ邪 */
					throw __LINE__;
				case '{':
					if(info.base_half){
					    throw __LINE__;
					}
					if(info.base.size() > 1){
					    throw __LINE__;
					}
					info.base_half=true;
					break;
				case '}':
					if(!info.base_half){
					    throw __LINE__;
					}
					info.base_half=false;
					break;
				case '*':	/* ̎1ߖ */
					/* ̎̋؂āA\̎Ɖ̎āAԂo߂ */
					timeArray.push_back(make_pair(info.time, 0));
					timeArray.push_back(make_pair(info.time, 3));
					timeAdd(info, timeArray);
					break;
				case '%':	/* \̎n܂肾A1ߖڂłȂ */
					/* ̎̋؂āA\̎āAԂo߂ */
					timeArray.push_back(make_pair(info.time, 0));
					timeArray.push_back(make_pair(info.time, 2));
					timeAdd(info, timeArray);
					break;
				case '+':	/* ̎2ߖڈȍ~ */
					/* ̎āAԂo߂ */
					timeArray.push_back(make_pair(info.time, 1));
					timeAdd(info, timeArray);
					break;
				case '-':	/* ȂƂ */
					/* Ԃo߂ */
					timeAdd(info, timeArray);
					break;
				case '/':	/* ̉̎̑Oɑł؂ꍇ */
					/* ̎̋؂āAԂo߂ */
					timeArray.push_back(make_pair(info.time, 0));
					timeAdd(info, timeArray);
					break;
				}
			}
			break;
		}
	}
L1:
	timeArray.push_back(make_pair(info.time, 0));	/* IA؂Ă */
	
	/* ŁACӂ̕\̎΂āA؂肪ɑ݂Aꂪ\̎̏IƂȂB */
	
	vector<string>::iterator itrLyrics = lyricsArray.begin();
	vector<string>::iterator itrKanjiLyrics = lyricsKanjiArray.begin();
	bool flag = true;	/* O؂肾̃tO */
	/* ŏɋ؂ȂĂȂ̂ŁAtrueOK */
	for(vector<pair<double, int> >::iterator itr = timeArray.begin();
			itr != timeArray.end(); itr++){
		if((*itr).second <= -1){	/* ߐȂǂ鎞 */
			if((*itr).second == -1){	/* ߐ */
				printf("=");
			}else{	/*  */
				printf("-");
			}
			printf("%lf\n", (*itr).first);
		}else if((*itr).second >= 1){	/* ̎̓鎞 */
			if((*itr).second & 2){	/* \̎̓鎞 */
				if(itrKanjiLyrics == lyricsKanjiArray.end()){
					throw __LINE__;
				}
				printf("*%lf %s\n", (*itr).first, (*itrKanjiLyrics).c_str());
				itrKanjiLyrics++;
				flag = false;
			}
			if((*itr).second & 1){	/* ł̎̓鎞 */
				if(itrLyrics == lyricsArray.end()){	/* łׂ̎Ƃɉ̎Ȃ */
					throw __LINE__;
				}
				printf("+%lf %s\n", (*itr).first, (*itrLyrics).c_str());
				itrLyrics++;
			}
		}else{	/* ̎̋؂̓鎞 */
			if(!flag){	/* ؂肪A邱Ƃh~ */
				printf("/%lf\n", (*itr).first);
			}
			flag = true;
		}
//printf("%lf %d\n",(*itr).first,(int)(*itr).second);
	}
	return 0;
}

int main(int argc, char **argv){
	if(argc < 2){
		return 0;
	}
	try{
		main1(argv[1]);
	}catch(int n){
		fprintf(stderr, "Error %d\n",n);
		getchar();
	}
	return 0;
}
